﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Windows.DataPresenter;

namespace xamGrid_testNulablePerformance
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            xamDataGrid1.DataSource = mydata.GetData;
        }

        private void xamDataGrid1_Loaded(object sender, RoutedEventArgs e)
        {
            Field field = xamDataGrid1.FieldLayouts[0].Fields[0];
            field.DataType = typeof(DateTime?);

            field.Settings.EditorStyle = (Style)root.FindResource("DateCellStyle");
        
            field.Settings.EditAsType = typeof(DateTime?);

        }
    }

    public class mydata
    {

        public static List<data> GetData
        {
            get
            {
                List<data> a = new List<data>();
                a.Add(new data() { val = DateTime.Now.AddDays(1).AddHours(5) });
                a.Add(new data() { val = null});
                a.Add(new data() { val = DateTime.Now.AddDays(1).AddHours(5) });
                a.Add(new data() { val = null });
                a.Add(new data() { val = DateTime.Now.AddDays(1).AddHours(5) });
                a.Add(new data() { val = DateTime.Now.AddDays(2).AddHours(3) });
                for (int i = 0; i <= 10000; i++)
                {
                    a.Add(new data() { val = DateTime.Now });
                }
                return a;
            }
        }

    }

    public class conv : IValueConverter
    {

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            //in case the day is friday make it null
            if (value != null && (value as DateTime?).Value.DayOfWeek == System.DayOfWeek.Friday)
            {
                return null;
            }
        
            return value;

        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }
    }

    public class data
    {
        public DateTime? val { get; set; }
    }

}
